﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridActiveItem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ((ViewModel)this.DataContext).Show();
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;

        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }

        }

    }

    public class ViewModel
    {
        public ObservableCollection<Person> Data { get; set; }

        public ObservableCollection<Person> Data2 { get; set; }

        private Person activePerson;

        public Person ActivePerson
        {
            get 
            { 
                return activePerson;
            }
            set 
            { 
                activePerson = value;
            }
        }

        private Person newActivePerson;

        public Person NewActivePerson
        {
            get
            {
                return newActivePerson;
            }
            set
            {
                newActivePerson = value;
            }
        }

        public ViewModel()
        {
            Data = new ObservableCollection<Person>();
            Data.Add(new Person() { Id = 0, Age = 10, LastName = "name1" });
            Data.Add(new Person() { Id = 1, Age = 20, LastName = "name2" });
            Data.Add(new Person() { Id = 2, Age = 30, LastName = "name3" });

            Data2 = new ObservableCollection<Person>();
            Data2.Add(new Person() { Id = 0, Age = 10, LastName = "name1" });
            Data2.Add(new Person() { Id = 1, Age = 20, LastName = "name2" });
            Data2.Add(new Person() { Id = 2, Age = 30, LastName = "name3" });

            ActivePerson = Data[1];            
        }

        public void Show()
        {
            NewActivePerson = ActivePerson;
        }
    }
}
